class Filesystem

  def self.begins_with_dot(path)
    return (path[0..0] == '.')
  end
  
  def self.get_subdirs(dir)
    subdirs = []

    Dir.open(dir) do |d|
      d.each do |entry|
        relative_path = File.join(dir, entry)
        if (File.directory?(relative_path) and not begins_with_dot(entry))
          subdirs << entry
        end
      end
    end
    
    return subdirs
  end
  
end
